/*
 * adjustrec : Ajust size of rectangle
 *                     20 Apr. 98   By Yasushi Sakurai
 */
#include        <stdio.h>
#include        "indexData.h"
#include        "brpData.h"

#define    DBG         0

extern int  irn, maxlevel;
extern struct  NodeData **noded;

extern double *rootIa, *rootIb;

int      adjustrec(pid, pnum, id, level)
int      pid;
int      pnum;
int      id;
int      level;
{
    int  i,j,flag=OFF;
    double t1[BUF_IRN], t2[BUF_IRN];

    if (level == maxlevel-1){
        for (j=0 ; j<noded[id]->num_child ; j++){
            for (i=0 ; i<irn ; i++){
               /*
                * set lower value
                */
                if (j==0 || t1[i] > noded[id]->cd[j].cent[i])
                    t1[i] = noded[id]->cd[j].cent[i];
               /*
                * set upper value
                */
                if (j==0 || t2[i] < noded[id]->cd[j].cent[i])
                    t2[i] = noded[id]->cd[j].cent[i];
            }
        }
    }
    else{
        for (j=0 ; j<noded[id]->num_child ; j++){
            for (i=0 ; i<irn ; i++){
               /*
                * set lower value
                */
                if (j==0 || t1[i] > noded[id]->cd[j].Ia[i])
                    t1[i] = noded[id]->cd[j].Ia[i];
               /*
                * set upper value
                */
                if (j==0 || t2[i] < noded[id]->cd[j].Ib[i])
                    t2[i] = noded[id]->cd[j].Ib[i];
            }
        }
    }
    for (i=0 ; i<irn ; i++){
        if (level != -1){
            if (noded[pid]->cd[pnum].Ia[i] != t1[i] || 
                    noded[pid]->cd[pnum].Ib[i] != t2[i]){
                flag = ON;
#if DACCESS
                if (noded[pid]->cd[pnum].Ia[i] < t1[i] ||
                    noded[pid]->cd[pnum].Ib[i] > t2[i])
                    flag = CONTRACTION;
#endif
                noded[pid]->cd[pnum].Ia[i] = t1[i];
                noded[pid]->cd[pnum].Ib[i] = t2[i];
            }
        }
        else {
#if ENTIRE
            if (rootIa[i] > t1[i] || rootIb[i] < t2[i]){
                rootIa[i] = t1[i];
                rootIb[i] = t2[i];
                flag = ON;
            }
#else
            if (rootIa[i] != t1[i] || rootIb[i] != t2[i]){
                flag = ON;
#if DACCESS
                if (rootIa[i] < t1[i] || rootIb[i] > t2[i])
                    flag = CONTRACTION;
#endif
                rootIa[i] = t1[i];
                rootIb[i] = t2[i];

            }
#endif
        }
    }
    return flag;
}
