/*
 * f_lengcode
 *                     1 Dec. 98   By Yasushi Sakurai
 */
#include        <stdio.h>
#include        <math.h>
#include        "indexData.h"
#define         LOG(a, b)     (log(b)/log(a))

#define         DBG         0

extern int                change();
extern int  irn, nlb;

int      f_lengcode(lengc, pcodea, pcodeb, total)
int     *lengc;
double  *pcodea;
double  *pcodeb;
int      total;
{
    int i, j, k, rest, tleng=0, sig_irn=0;
    double pv, mv=1, interval[BUF_IRN], tmp;
    struct  SortData buf_sd[1];
    struct  SortData *sd=buf_sd;
    struct  NetData  buf_net[BUF_IRN];
    sd->netd = buf_net;

/*
for (i=0 ; i<irn ; i++)
  lengc[i] = nlb;
return;
*/
    sig_irn = 0;
    for (i=0 ; i<irn ; i++){
        interval[i] = pcodeb[i] - pcodea[i];
        if (interval[i] == 0.0)
            lengc[i] = 0;
        else{
            sig_irn++;
            mv = mv * interval[i];
#if DBG
printf("i=%d %f\n",i,interval[i]);
#endif
	}
    }
    if (sig_irn == 0)
        return 0;

    tmp = (double)1 / (double)sig_irn;
    pv = pow(pow(2, total)/mv, tmp);

#if DBG
printf("pv=%f mv=%f total=%d\n",pv,mv,total);
#endif
    j = 0;
    for (i=0 ; i<irn ; i++){
        if (interval[i] != 0){
            lengc[i] = (int)(LOG(2, pv * interval[i]) + 0.5);
            if (lengc[i] < 0)
                lengc[i] = 0;
            if (lengc[i] > total)
                lengc[i] = total;
	}
        j += lengc[i];
#if DBG
if (lengc[i] != 0)
printf("i=%d length=%d\n",i,lengc[i]);
#endif
    }
    if (sig_irn == 0) return;
    rest = total - j;
#if DBG
printf("rest=%d\n",rest);
#endif
    if (rest != 0){
        sd->num=0;
        for (i=0 ; i<irn ; i++){
            if (rest > 0 && interval[i] !=0 || rest < 0 && lengc[i] != 0){
                tmp = pow(2, lengc[i]);
                sd->netd[sd->num].distance = interval[i] / tmp;
                sd->netd[sd->num].id = i;
                sd->num++;
	    }
        }
        qsort(sd->netd, sd->num, sizeof(struct NetData), change);

#if DBG
for (i=0 ; i<sd->num ; i++)
printf("dist=%f dim=%d\n",sd->netd[i].distance,sd->netd[i].id);
#endif

        if (rest > 0){
            k = sd->num - 1;
            for (i=rest ; i>0 ; i--){
                if (k==-1) k = sd->num-1;
                j = sd->netd[k].id;
                lengc[j]++;
                k--;
	    }
	}
        else{
            k=0;
            for (i=rest ; i<0 ; i++){
                if (k==sd->num) k = 0;
                j = sd->netd[k].id;
                lengc[j]--;
                k++;
	    }
        }
    }

    for (i=0 ; i<irn ; i++)
        if (lengc[i] > 31)
            lengc[i] = 31;

    for (i=0 ; i<irn ; i++)
        tleng += lengc[i];

#if DBG
for (i=0 ; i<irn ; i++)
if (lengc[i] != 0)
printf("i=%d length=%d\n",i,lengc[i]);
#endif

    return tleng;
}
