/* Program name --- map_read.c
 *       written by Sakurai   1998.2.17
 */

#include        <stdio.h>
#include        <stdlib.h>
#include        <string.h>
#include        "indexData.h"
#include        "accData.h"

extern void  pack_page();

struct AccData *map_read(map_file)
char	*map_file;
{
    FILE   *fp_map;

    struct  AccData *accd;
    int    *mapsizeX,mapsizeY,**map,*acc,*page;
    int     maxpage, max_column=0;

    int     column[MAX]={D_ADD,D_NODED,D_OBJECTD,D_NODED};

    char    read_buf[10000],tmp[10000];
    char    *strp1,*strp2;
    int    *buf_int;
    int    i, j, k;

    accd  = (struct AccData *)malloc(sizeof(struct AccData));

    if ( ( fp_map = fopen ( map_file , "r" ) ) == NULL ){
        printf( "  %s can not open\n" , map_file);
        exit(1);
    }

   /*
    * set mapsizeY
    */
    mapsizeY=0;
    while (fgets(tmp,10000,fp_map) != NULL ){
        mapsizeY++;
        strcpy(read_buf,tmp);
    }

   /*
    * set maxpage
    */
    strp1 = read_buf;
    j = 0;
    while( strp2 = strtok( strp1 , " " )){
        if (strp2 == NULL ) break;
        if ( j != 0) maxpage = atoi(strp2);
        strp1 = NULL;
        j++;
    }
    maxpage += 1;

   /*
    * set mapsizeX
    */
    i = 0;
    k = 0;
    mapsizeX = (int *)malloc(sizeof(int) * mapsizeY);
    rewind(fp_map);
    while (fgets(tmp,10000,fp_map) != NULL ){
        strp1 = tmp;
        j = 0;
        while(strp2 = strtok(strp1," ")){
            if (strp2 == NULL) break;
            strp1 = NULL;
            j++;
        }
        mapsizeX[i] = j;
        i++;
    }

    for (i=0 ; i<MAX ; i++) {
        if (max_column < column[i])
            max_column = column[i];
    }

    pack_page(accd);
#if MOVMBR
    if (accd->vol_r_non > accd->vol_r_leaf)
        j = D_NODED + accd->vol_r_non;
    else
        j = D_NODED + accd->vol_r_leaf;
#else
    if (accd->vol_r_non > accd->vol_r_leaf && accd->vol_r_non > accd->vol_r_non2){
        j = D_NODED + accd->vol_r_non;
    }
    else{
        if (accd->vol_r_non2 > accd->vol_r_leaf)
            j = D_NODED + accd->vol_r_non2;
        else
            j = D_NODED + accd->vol_r_leaf;
    }
#endif

    buf_int = (int *)malloc(sizeof(int) * (maxpage + max_column+1 + mapsizeY*j));
    page = buf_int;
    buf_int += maxpage;
    acc = buf_int;
    buf_int += max_column+1;

    map = (int **)malloc(sizeof(int *) * mapsizeY);
    k = 0;
    for (i=0 ; i<mapsizeY ; i++){
        map[i] = buf_int + k;
        k += j;
    }

   /*
    * set map
    */
    i=0;
    rewind(fp_map);
    while(fgets(read_buf, 10000, fp_map)){
        strp1 = read_buf;
        j = 0;
        while(strp2 = strtok(strp1," ")){
            if (strp2 == NULL) break;
            map[i][j] = atoi(strp2);
            strp1 = NULL;
            j++;
            if (j == mapsizeX[i]) break;
        }
        i++;
    }

    fclose(fp_map);

    accd->maxpage = maxpage;
    accd->mapsizeX = mapsizeX;
    accd->mapsizeY = mapsizeY;
    accd->page = page;
    accd->map = map;
    accd->acc = acc;

    return accd;
}
