/* Program name --- map_write.c
 *       written by Sakurai   1998.5.20
 */

#include        <stdio.h>
#include        <string.h>
#include        "accData.h"

void map_write(accd, map_file)
struct AccData *accd;
char	*map_file;
{
    FILE   *fp;
    int    *mapsizeX,mapsizeY,**map;
    int    i, j;

    mapsizeX = accd->mapsizeX;
    mapsizeY = accd->mapsizeY;
    map = accd->map;

    if ( ( fp = fopen ( map_file , "w" ) ) == NULL ){
        printf( "  %s can not open\n" , map_file);
        exit(1);
    }

   /*
    * write map
    */
    for (i=0 ; i<mapsizeY ; i++){
        for (j=0 ; j<mapsizeX[i] ; j++){
            fprintf(fp, "%d",map[i][j]);
            if (j!=mapsizeX[i]-1)
                fprintf(fp, " ");
            else
                fprintf(fp, "\n");
        }
    }

    fclose(fp);
}
