/* Program name --- pack_page.c
 *       written by Sakurai   1998.2.17
 */

#include        <stdio.h>
#include        <stdlib.h>
#include        <string.h>
#include        "indexData.h"
#include        "accData.h"

extern int nlb, irn, maxnode, maxnode_l;

void  pack_page(struct AccData *accd){

    int    k, allbyte2, module_size;

    k = nlb*irn*2;
    allbyte2 = (int)(k*maxnode / 8);
    if (k*maxnode % 8 != 0)
        allbyte2++;
#if MOVMBR
    module_size = INT_SIZE + allbyte2 + irn * 2 * FLOAT_SIZE + maxnode * INT_SIZE;
#else
    module_size = INT_SIZE + maxnode * (INT_SIZE+OFFSET_SIZE) + allbyte2;
#endif
    accd->vol_frac_v_non = (int)(PAGESIZE/module_size);

    k = nlb*irn;
    allbyte2 = (int)(k*maxnode_l / 8);
    if (k*maxnode % 8 != 0)
        allbyte2++;
#if MOVMBR
    module_size = INT_SIZE * 2 + allbyte2 + irn * 2 * FLOAT_SIZE;
#else
    module_size = INT_SIZE * 2 + allbyte2;
#endif
    accd->vol_frac_v_leaf = (int)(PAGESIZE/module_size);

#if MOVMBR
    module_size = maxnode * INT_SIZE + maxnode * irn * FLOAT_SIZE;
#else
    module_size = INT_SIZE + maxnode * 2 * INT_SIZE + maxnode * irn * FLOAT_SIZE;
#endif
    accd->vol_r_non = (int)(module_size/PAGESIZE + 1);
    if (module_size % PAGESIZE == 0)
        accd->vol_r_non--;

#if MOVMBR
#else
    module_size = maxnode * irn * 2 * FLOAT_SIZE;
    accd->vol_r_non2 = (int)(module_size/PAGESIZE + 1);
    if (module_size % PAGESIZE == 0)
        accd->vol_r_non2--;
#endif

#if MOVMBR
    module_size = maxnode_l * INT_SIZE + maxnode_l * irn * FLOAT_SIZE + maxnode_l * NAME_SIZE;
#else
    module_size = (1 + maxnode_l) * INT_SIZE + maxnode_l * irn * FLOAT_SIZE + maxnode_l * NAME_SIZE;
#endif
    accd->vol_r_leaf = (int)(module_size/PAGESIZE + 1);
    if (module_size % PAGESIZE == 0)
        accd->vol_r_leaf--;
}
