/*
 * adjustsph : Ajust size of sphere
 *                     10 Dec. 98   By Yasushi Sakurai
 */
#include        <stdio.h>
#include        <math.h>
#include        "indexData.h"

#define    DBG         0

extern int  irn, maxlevel;
extern struct  NodeData **noded;

void     adjustsph(pid, pnum, id, level)
int      pid;
int      pnum;
int      id;
int      level;
{
    int  i, j, omega=0;
    double mean, t1, t2, dist;

   /*
    * calculate omega in the current node
    */
    for (i=0 ; i<noded[id]->num_child ; i++)
        omega +=noded[id]->cd[i].omega;
    noded[pid]->cd[pnum].omega = omega;

   /*
    * calculate the center point of the current node
    */
    for (i=0 ; i<irn ; i++){
        mean = 0.0;
        for (j=0 ; j<noded[id]->num_child ; j++)
            mean += noded[id]->cd[j].cent[i] * noded[id]->cd[j].omega;
        noded[pid]->cd[pnum].cent[i] = mean / (double)noded[pid]->cd[pnum].omega;
    }
}
