/*
 * setcode
 *                     20 Apr. 98   By Yasushi Sakurai
 */
#include        <stdio.h>
#include        "indexData.h"
#include        "accData.h"
#include        "brpData.h"

extern void    getlb_v();
#if VLC
extern int     f_lengcode();
#endif

#if DACCESS
extern struct AccData    *daccess();
extern struct AccData    *accd;
#endif

extern int  maxlevel;
extern int  maxnode, maxnode_l;
extern struct  NodeData **noded;

extern int  allbit, allbit_c;

extern int  irn, nlb;

void    setcode(pcodea, pcodeb, id, num, mode, level)
double *pcodea;
double *pcodeb;
int  id;
int  num;
int  mode;
int  level;
{

    int  i,j;
    unsigned int  buf_bit[BUF_NLB*BUF_IRN], buf_bit2[BUF_NLB*BUF_IRN];
    unsigned int *tmpbit=buf_bit, *tmpbit2=buf_bit2;
    int  tleng;
#if VLC
    int  lengc[BUF_IRN];

    if (level == maxlevel)
        tleng = (int)(nlb * irn * maxnode_l / (double)noded[id]->num_child);
    else
        tleng = (int)(nlb * irn * maxnode / (double)noded[id]->num_child);
    tleng = f_lengcode(lengc, pcodea, pcodeb, tleng);

#else
    tleng = nlb * irn;
#endif

#if DACCESS
    accd->acc[0] = NODED;
    accd->acc[1] = id;
    accd->acc[2] = VIRTUAL;
    accd = daccess(accd);
#endif

   /* update leaf node */
    if (level == maxlevel){
        if (mode == ALL){
            for (i=0 ; i<noded[id]->num_child ; i++){
#if VLC
                getlb_v(noded[id]->lbit_cent, pcodea, pcodeb, noded[id]->cd[i].cent, noded[id]->cd[i].cent, tleng*i, POINT, lengc);
#else
                getlb_v(noded[id]->lbit_cent, pcodea, pcodeb, noded[id]->cd[i].cent, noded[id]->cd[i].cent, tleng*i, POINT);
#endif
            }
	}
        else{
#if VLC
            getlb_v(noded[id]->lbit_cent, pcodea, pcodeb, noded[id]->cd[num].cent, noded[id]->cd[num].cent, tleng*num, POINT, lengc);
#else
            getlb_v(noded[id]->lbit_cent, pcodea, pcodeb, noded[id]->cd[num].cent, noded[id]->cd[num].cent, tleng*num, POINT);
#endif
	}
    }
   /* update non-leaf node */
    else{
        if (mode == ALL){
            for (i=0 ; i<noded[id]->num_child ; i++){
#if VLC
                getlb_v(noded[id]->loc_bit, pcodea, pcodeb, noded[id]->cd[i].Ia, noded[id]->cd[i].Ib, tleng*2*i, RECT, lengc);
#else
                getlb_v(noded[id]->loc_bit, pcodea, pcodeb, noded[id]->cd[i].Ia, noded[id]->cd[i].Ib, tleng*2*i, RECT);
#endif
            }
	}
        else{
#if VLC
            getlb_v(noded[id]->loc_bit, pcodea, pcodeb, noded[id]->cd[num].Ia, noded[id]->cd[num].Ib, tleng*2*num, RECT, lengc);
#else
            getlb_v(noded[id]->loc_bit, pcodea, pcodeb, noded[id]->cd[num].Ia, noded[id]->cd[num].Ib, tleng*2*num, RECT);
#endif
	}
    }
}
