#include	<stdio.h>
#include	<string.h>
#include	<math.h>
#include        "indexData.h"

extern double             euclid_m();
extern void               getver();

double   verleng(rcodea, rcodeb, qcode, mode, irn)
double  *rcodea;
double  *rcodeb;
double  *qcode;
int      mode;
int      irn;
{
    int    i,j;
    double  buf_code1[BUF_IRN],buf_code2[BUF_IRN];
    double *anscode=buf_code1, *tmpcode=buf_code2;
    double  tmp1,tmp2,tmp3,dist;

    switch(mode) {
    case MINDIST:
        getver(anscode, rcodea, rcodeb, qcode, mode, irn);
        dist = euclid_m(qcode, anscode, irn);
        break;
    case MINMAX:
        for (i=0 ; i<irn ; i++) {
            tmp1 = (double)(rcodea[i]+rcodeb[i]) / (double)2;
            if (qcode[i] <= tmp1)
                tmp2 = rcodea[i];
            else 
                tmp2 = rcodeb[i];
            for (j=0 ; j<irn ; j++){
                tmp1 = (double)(rcodea[j]+rcodeb[j]) / (double)2;
                if (j==i)
                    tmpcode[j] = tmp2;
                else{
                    if (qcode[j] >= tmp1)
                        tmpcode[j] = rcodea[j];
                    else
                        tmpcode[j] = rcodeb[j];
                }
            }
            tmp3 = euclid_m(qcode, tmpcode, irn);
            if (i == 0 || dist > tmp3){
                dist = tmp3;
                for (j=0 ; j<irn ; j++)
                    anscode[i] = tmpcode[i];
            }
        }
        break;
    case MAXDIST:
        getver(anscode, rcodea, rcodeb, qcode, mode, irn);
        dist = euclid_m(qcode, anscode, irn);
        break;
    }
    return dist;
}
